player = {}
player.img = {}													--a list of all player animation frames in a table
player.weapon = {}

player.img[1] = love.graphics.newImage("art/run1.png")			--load player art assets
player.img[2] = love.graphics.newImage("art/run2.png")
player.img[3] = love.graphics.newImage("art/run3.png")
player.img[4] = love.graphics.newImage("art/run4.png")
player.img[5] = love.graphics.newImage("art/run5.png")
player.img[6] = love.graphics.newImage("art/stand.png")
player.img[7] = love.graphics.newImage("art/crouch.png")
player.img[8] = love.graphics.newImage("art/cover.png")
player.img[9] = love.graphics.newImage("art/fire1.png")
player.img[10] = love.graphics.newImage("art/fire2.png")
player.img[11] = love.graphics.newImage("art/standfire1.png")
player.img[12] = love.graphics.newImage("art/standfire2.png")
player.img[13] = love.graphics.newImage("art/run1b.png")
player.img[14] = love.graphics.newImage("art/run2b.png")
player.img[15] = love.graphics.newImage("art/run3b.png")
player.img[16] = love.graphics.newImage("art/run4b.png")
player.img[17] = love.graphics.newImage("art/run5b.png")
player.img[18] = love.graphics.newImage("art/runfire1.png")
player.img[19] = love.graphics.newImage("art/runfire2.png")
player.img[20] = love.graphics.newImage("art/runfire3.png")
player.img[21] = love.graphics.newImage("art/runfire4.png")
player.img[22] = love.graphics.newImage("art/runfire5.png")

for i = 1,22 do													--filter images to avoid blur
	player.img[i]:setFilter("nearest", "nearest")
end 

function player.load()											--loads initial variables
	player.x = 100												--player's initial x position
	player.y = 300												--player's initial y position
	player.xvel = 0												--player's x velocity
	player.yvel = 0												--player's y velocity
	player.friction = 5											--player's friction
	player.speed = 350											--player's max speed
	player.dir = 2												--pLayer's initial direction ( 2 = right -2 = left ) also used to scale/mirror the player's image 	
	player.stancedelay = 0										--delay between changing stances
	player.animtimer = 0										--delay timer between frames
	player.currentAnim = "stand"								--sets player's current animation
	player.readytofire = 0
	player.currentFrame = player.img[6]
	pnum = 1
	inum = 1
	player.fireSound = love.audio.newSource("sfx/rifle_fire.wav")
	player.fireSound:setVolume(.05)
	player.weapon.type = "rifle"
	
end

function player.draw()											--sets colour and draws the player
	love.graphics.setColor(255,255,255)
	love.graphics.draw(player.currentFrame, player.x - player.dir * 7 ,player.y,0,player.dir,2)		--player.dir * n - changes point where player turns from
	love.graphics.print(player.weapon.bulletNum,10,10)
end

function player.changeWeapon(dt)            -- changes current weapon
	if player.weapon.type == "rifle" then 
		player.weapon.magSize = 30
		player.weapon.maxRange = 100
		player.weapon.fireRate = 2
		player.weapon.reloadTime = 20
    player.weapon.damage = 1
		player.weapon.bulletNum = player.weapon.magSize
	end
end

function player.movement(dt)									--deals with all player movement
	player.x = player.x + player.xvel * dt
	player.y = player.y + player.yvel * dt
	player.xvel = player.xvel * (1 - math.min(dt * player.friction, 1))
	player.yvel = player.yvel * (1 - math.min(dt * player.friction, 1))
  
	if love.keyboard.isDown("lshift") then 
    player.speed = 500 else player.speed = 350 
  end
	if love.keyboard.isDown("d") then 
		player.xvel = player.xvel + player.speed * dt
		player.dir = 2
	end
	if love.keyboard.isDown("a") then
		player.xvel = player.xvel - player.speed * dt
		player.dir = -2
	end
	if love.keyboard.isDown("w") then player.yvel = player.yvel - (player.speed / 1.5) * dt end
	if love.keyboard.isDown("s") then player.yvel = player.yvel + (player.speed / 1.5) * dt end
	if love.keyboard.isDown("c") then player.currentAnim = "crouch" end
	if love.keyboard.isDown("x") then player.currentAnim = "stand" end
	if love.keyboard.isDown("r") then 
		player.readytofire = player.weapon.reloadTime
		player.weapon.bulletNum = player.weapon.magSize
	end
	if love.keyboard.isDown(" ") and player.readytofire == 0 then
    if player.weapon.bulletNum > 0 then 
      player.fireSound:stop()
      player.fireSound:play()
      player.readytofire = player.weapon.fireRate
      player.weapon.bulletNum = player.weapon.bulletNum - 1
      zombie.hitDetection()
      -- detect player direction
      if player.dir == 2 then bullet.insert(player.x + math.random(500) + 100, player.y + math.random(24) - 4) end
      if player.dir == -2 then bullet.insert(player.x - math.random(500) - 100, player.y + math.random(24) - 4) end
      --set animation
      if player.currentAnim == "crouch" or player.currentAnim == "cover" then 
        pnum = 8
        player.currentAnim = "firecrouch" 
      elseif player.currentAnim == "stand" then
        pnum = 10
        player.currentAnim = "firestand"
      end
		end
	end	
	if player.readytofire > 0 then player.readytofire = player.readytofire - .01 else player.readytofire = 0 end
	
end

function player.animation(dt)
	if player.yvel < -10 or player.yvel > 10 then player.currentAnim = "runvert" end		-- sets player's animation to running if x velocity is fast enough
	if player.xvel < -10 or player.xvel > 10 then player.currentAnim = "runhori" end
	if player.currentAnim == "runhori" or player.currentAnim == "runvert" then
		player.readytofire = .1
		if player.xvel > -10 and player.xvel < 10 and player.yvel > -10 and player.yvel < 10 then player.currentAnim = "stand" end		-- sets player's animation to running if x velocity is fast enough
	end
	if player.currentAnim == "runhori" or player.currentAnim == "runvert" or player.currentAnim == "firecrouch" or player.currentAnim == "firestand" then
		player.animtimer = player.animtimer + dt
		if player.animtimer > .1 then
			pnum = pnum + 1
			player.animtimer = 0
			if player.currentAnim == "runhori" then
				if pnum < 1 or pnum > 5 then pnum = 1 end
			end
			if player.currentAnim == "runvert" then
				if pnum < 13 or pnum > 17 then pnum = 13 end 
			end
			if player.currentAnim == "firecrouch" and pnum > 10 then player.currentAnim = "crouch" end
			if player.currentAnim == "firestand" and pnum > 12 then player.currentAnim = "stand" end
			player.currentFrame = player.img[pnum] 
		end
	end
	if player.currentAnim == "stand" then player.currentFrame = player.img[6] end	-- sets players single frames
	if player.currentAnim == "crouch" then player.currentFrame = player.img[7] end
	if player.currentAnim == "cover" then player.currentFrame = player.img[8] end
	
end