zombie = {}
zombie.img = {}
zombie.img[1] = love.graphics.newImage("art/zwalk1.png")
zombie.img[2] = love.graphics.newImage("art/zwalk2.png")
zombie.img[3] = love.graphics.newImage("art/zwalk3.png")
zombie.img[4] = love.graphics.newImage("art/zwalk4.png")
zombie.img[5] = love.graphics.newImage("art/zhit1.png")
zombie.img[6] = love.graphics.newImage("art/zhit2.png")
zombie.img[7] = love.graphics.newImage("art/zdying1.png")
zombie.img[8] = love.graphics.newImage("art/zdying2.png")
zombie.img[9] = love.graphics.newImage("art/zdying3.png")
zombie.img[10] = love.graphics.newImage("art/zdying4.png")
zombie.img[11] = love.graphics.newImage("art/zdead.png")
zombie.hitSound = love.audio.newSource("sfx/zhit.mp3")
zombie.hitSound:setVolume(.1)
zombie_speed = 13
zspawn = 0
for i=1,11 do zombie.img[i]:setFilter("nearest", "nearest") end


function zombie.spawn(x,y, frame, animtimer, znum, health, animStart, animFinish, currentAnim)
	table.insert(zombie, {x = x, y = y, frame = zombie.img[1], animtimer = 0, znum = 1, health = 10, animStart = 1, animFinish = 4, currentAnim = "walking"})
end

function zombie.draw()
	for i,v in ipairs(zombie) do
		love.graphics.setColor(255, 255, 255)
		love.graphics.draw(v.frame,v.x,v.y,0,2,2)
	end
end

function zombie.update(dt)
	for i,v in ipairs(zombie) do
		if v.currentAnim == "dead" then 
			v.znum = 11
		else
			if v.currentAnim == "walking" then 
				v.animStart = 1
				v.animFinish = 4
			end
			if v.currentAnim == "hit" then 
				v.animStart = 4
				v.animFinish = 6
			end
			if v.currentAnim == "dying" then 
				v.animStart = 7
				v.animFinish = 10
			end		
			if v.health < 0 then v.currentAnim = "dying" end
			if v.currentAnim ~= "dying" then v.x = v.x - math.random(zombie_speed) * dt end
			v.animtimer = v.animtimer + dt / 10
			if v.animtimer > .02 then
				v.animtimer = 0
				v.znum = v.znum + 1
				if v.znum > v.animFinish then 
					if v.currentAnim == "hit" then v.currentAnim = "walking" end
					if v.currentAnim == "dying" then v.currentAnim = "dead" end
					v.znum = v.animStart
				end
			end
		end	
		v.frame = zombie.img[v.znum]
	end
end

function zombie.make(dt)
	zspawn = zspawn - dt
	if zspawn < 0 then 
		zombie.spawn(800, math.random(200) + 200) 
		zspawn = math.random(10)
	end
end

function zombie.hitDetection()
	for i,v in ipairs(zombie) do
		if v.y < player.y + 20 and v.y > player.y - 4 and v.currentAnim ~= "dead" then 
			if v.x > player.x and player.dir == 2 or v.x < player.x and player.dir == -2 then zombie.hitChance(v)	end
		end
	end
end

function zombie.hitChance(v)
	hit = math.random(100)			
	hitChance = 95
	if player.currentAnim == "firestand" then hitChance = hitChance - 80 end
	if hit < hitChance then 
		zombie.hitSound:stop()
		zombie.hitSound:play()
		v.health = v.health - 3
		v.currentAnim = "hit"
	end
end

